/*
 * serverconfig.h
 * Interface to configuration data for the server.
 *
 * Copyright (C) Leni Mayo 2002
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License, version 2, as
 *	published by the Free Software Foundation.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef _SERVERCONFIG_H_
#define _SERVERCONFIG_H_

typedef enum
{
	eConfigKeyRdfDbIgnore     = 0,  /* bool:   server to ignore the rdf db     */
	eConfigKeyRdfDbDirectory  = 1,  /* string: directory containing the rdf db */
	eConfigKeyRdfDbFormat     = 2,  /* string: rdf db format eg bdb/gdbm       */
	eConfigKeyRdfParser       = 3,  /* string: rdf parser name,  eg. "repat"   */
	eConfigKeyServiceUriSeq   = 4,  /* string: semi-colon-delimited seq of uri */
	eConfigKeyBaseUri         = 5,  /* string: the base uri for parsed rdf     */
	eConfigKeyMangleDollar    = 6,  /* string: how to mangle the '$' prefix    */
	eConfigKeyLast            = 7   /* just an end-of marker                   */
} ConfigKey;

const char *configAsString(ConfigKey key);
int configAsBool(ConfigKey key);

void configInitialise(const char *pszFilename);
void configCleanup();

#endif /* _SERVERCONFIG_H_ */
